package nl.tbdev.asterisk.demo;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Vector;

public class Server extends Thread {
	private ServerSocket server = null;
	private Vector detectors = null;
	
	Server(Vector v) {
		detectors = v;
		startServer();
		start();
	}
	
	private void startServer() {
		try {
			server = new ServerSocket(8081);
		} catch (Exception e) {
			System.out.println("Exception: "+e);
			System.exit(1);
		}
	}
	
	public void run() {
		try {
			while ( true ) {
				Socket s = server.accept();
				System.out.println("Got connection");
				addDetector(s);
			}
		} catch (Exception e) {
			System.out.println("Exception in accept: "+e);
		}
	}
	
	private void addDetector(Socket s) {
		//		Detector d = new Detector("SIP/prive1@prive1", "701", "switch", "45000", "424", "SIP/172.16.1.200:5060", "E8000006E184AD01");
		// get identity of remote
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(s.getInputStream()));
			String sip = in.readLine().trim();
			String ext = in.readLine().trim();
			String context = in.readLine().trim();
			String timeout = in.readLine().trim();
			String call = in.readLine().trim();
			String watch = in.readLine().trim();
			String id = in.readLine().trim();
			Detector d = new Detector(sip, ext, context, timeout, call, watch, id);

			// delete if present
			boolean found = false;
			for ( int i = 0; !found && i < detectors.size(); i++) {
				Detector dd = (Detector) detectors.elementAt(i);
				if ( dd.getIbutton().equals(id))
				{
					found = true;
					detectors.removeElementAt(i);
				}
			}
			detectors.addElement(d);
			d.setSocket(s);
			d.setReader(in);
		} catch (Exception e) {
			System.out.println("Exception while registering device: "+e);
		}
	}
}
